/*
 * mbox_derive_from.c
 * Get us a mbox-style From_ header
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_derive_from.c,v 1.8 2001/05/05 05:08:33 fullermd Exp $
 */

#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>


void
mbox_derive_from(char **hdr_in)
{
	char *buf, *buf2, *buf3;
	char *from_hdr=NULL;
	char *xfrom=NULL, *retpath=NULL, *sender=NULL, *from=NULL;
	char *intbuf;
	int netform=0;

	intbuf = malloc(strlen(*hdr_in)+1);
	strcpy(intbuf, *hdr_in);
	buf = intbuf;

	/* 
	 * Ordering considerations:
	 * I've decided, unilaterally, in a undemocratic way,
	 * the order in which we'll search.
	 * Justifications:
	 * X-From_ - some POP servers (cucipop for ex:) seem to add it
	 * Return-Path || Sender || From: - mutt uses this order
	 */
	/* XXX This code could probably be made more efficient */
	while( (buf3=strstr(buf, "\r\n")) != NULL )
	{
		netform=1;
		*buf3 = '\0';
		buf3+=2;
		if(!(strncmp(buf, "From ", strlen("From "))))
		{
			/* We already have a From_ header */
			free(intbuf);
			intbuf = malloc(strlen(*hdr_in)+1);
			strcpy(intbuf, *hdr_in);
			return;
		}
		if(!(strncmp(buf, "X-From_:", strlen("X-From_:"))))
		{
			buf2 = strchr(buf, ':');
			buf2++;
			while(*buf2==' ')
				buf2++;
			xfrom = malloc(strlen(buf2)+1);
			strcpy(xfrom, buf2);
			/*
			 * XXX Special case, BAD!
			 * We have the 'default', let's break out and save some
			 * cycles
			 */
			break;
		}
		if(!(strncmp(buf, "Return_Path:", strlen("Return_Path:"))))
		{
			buf2 = strchr(buf, ':');
			buf2++;
			while(*buf2==' ')
				buf2++;
			retpath = malloc(strlen(buf2)+1);
			strcpy(retpath, buf2);
		}
		if(!(strncmp(buf, "Sender:", strlen("Sender:"))))
		{
			buf2 = strchr(buf, ':');
			buf2++;
			while(*buf2==' ')
				buf2++;
			sender = malloc(strlen(buf2)+1);
			strcpy(sender , buf2);
		}
		if(!(strncmp(buf, "From:", strlen("From:"))))
		{
			buf2 = strchr(buf, ':');
			buf2++;
			while(*buf2==' ')
				buf2++;
			from = malloc(strlen(buf2)+1);
			strcpy(from, buf2);
		}
		buf = buf3;
	}
	/* Just to be safe */
	if(netform==0)
	{
		while( (buf3=strchr(buf, '\n')) != NULL )
		{
			*buf3 = '\0';
			buf3++;
			if(!(strncmp(buf, "From ", strlen("From "))))
			{
				/* We already have a From_ header */
				free(intbuf);
				intbuf = malloc(strlen(*hdr_in)+1);
				strcpy(intbuf, *hdr_in);
				return;
			}
			if(!(strncmp(buf, "X-From_:", strlen("X-From_:"))))
			{
				buf2 = strchr(buf, ':');
				buf2++;
				while(*buf2==' ')
					buf2++;
				xfrom = malloc(strlen(buf2)+1);
				strcpy(xfrom, buf2);
				/*
				 * XXX Special case, BAD!
				 * We have the 'default', let's break out and save some
				 * cycles
				 */
				break;
			}
			if(!(strncmp(buf, "Return_Path:", strlen("Return_Path:"))))
			{
				buf2 = strchr(buf, ':');
				buf2++;
				while(*buf2==' ')
					buf2++;
				retpath = malloc(strlen(buf2)+1);
				strcpy(retpath, buf2);
			}
			if(!(strncmp(buf, "Sender:", strlen("Sender:"))))
			{
				buf2 = strchr(buf, ':');
				buf2++;
				while(*buf2==' ')
					buf2++;
				sender = malloc(strlen(buf2)+1);
				strcpy(sender , buf2);
			}
			if(!(strncmp(buf, "From:", strlen("From:"))))
			{
				buf2 = strchr(buf, ':');
				buf2++;
				while(*buf2==' ')
					buf2++;
				from = malloc(strlen(buf2)+1);
				strcpy(from, buf2);
			}
			buf = buf3;
		}
	}

	free(intbuf);

	/* Now decide */
	if(xfrom)
	{
		from_hdr = malloc(strlen(xfrom)+1);
		strcpy(from_hdr, xfrom);
	}
	else if(retpath)
	{
		from_hdr = malloc(strlen(retpath)+1);
		strcpy(from_hdr, retpath);
	}
	else if(sender)
	{
		from_hdr = malloc(strlen(sender)+1);
		strcpy(from_hdr, sender);
	}
	else if(from)
	{
		from_hdr = malloc(strlen(from)+1);
		strcpy(from_hdr, from);
	}
	free(xfrom);
	free(retpath);
	free(sender);
	free(from);

	/* Don't forget extra +6 for "From " and \n */
	intbuf = malloc( strlen(from_hdr) + strlen(*hdr_in)+1+6);
	sprintf(intbuf, "From %s\n%s", from_hdr, *hdr_in);
	free(*hdr_in);
	*hdr_in = malloc(strlen(intbuf)+1);
	strcpy(*hdr_in, intbuf);
	free(intbuf);
	free(from_hdr);
}
