/*
 * mbox_write_msg.c
 * Write a message into a mbox
 * libpostal project
 * libpost_raw mbox code
 * $Id: mbox_write_msg.c,v 1.4 2001/05/05 05:08:33 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_mbox_p.h>


void
mbox_write_msg(POSTAL_CONN *p_conn, POSTAL_MSG *msg)
{
	char *tmpstr;
	POSTAL_MSG *temp;

	/* We need to cure \r\n's if we have them... */
	/*
	 * XXX This is a target for optimization.
	 * Waste some memory to save some CPU.  Not worrying right now.
	 */
	temp = malloc(PMSG_SIZE);
	tmpstr = malloc((UMAX((strlen(msg->body)),(strlen(msg->header))))+1);
	tmpstr = postal_whack_cr(msg->header);
	temp->header = malloc(strlen(tmpstr)+1);
	strcpy(temp->header, tmpstr);
	tmpstr = postal_whack_cr(msg->body);
	temp->body = malloc(strlen(tmpstr)+1);
	strcpy(temp->body, tmpstr);

	mbox_derive_from(&temp->header);
	/*
	 * Spew it out.
	 * Note that we need 2 \n's, since foo->header doesn't have
	 * a trailing \n to begin with.
	 */
	fprintf(p_conn->spec.mbox->fref.mbox_file,
			"%s\n\n%s", temp->header, temp->body);

	/* Cleanup */
	free(temp->body);
	free(temp->header);
	free(temp);

	/* *flush*  */
	fflush(p_conn->spec.mbox->fref.mbox_file);
}
