/*
 * pop_dele.c
 * POP 'DELE' query
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_dele.c,v 1.2 2001/05/03 10:52:51 fullermd Exp $
 */

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/uio.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


int
pop_dele(POSTAL_CONN *p_conn, int msgnum)
{
	char buf[BUFFER_SIZE+1];
	int readlen;

	/* Send request */
	sprintf(buf, "DELE %d\r\n", msgnum);
	POP_CMD_SEND(p_conn, buf);
	CLEARSTRING(buf);

	/* Get the response */
	readlen=read(p_conn->spec.pop->sock, buf, BUFFER_SIZE);
	buf[readlen]='\0';

	/*
	 * Check it.
	 * If we don't get +OK, I dunno what we're supposed to do...
	 * This is a pretty simple function...
	 */
	if( (strncmp(buf, POP_GOOD, strlen(POP_GOOD)) != 0) )
		return(-1);
	return(0);
}
