/*
 * pop_retr.c
 * POP 'RETR' query
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_retr.c,v 1.4 2001/05/03 10:52:51 fullermd Exp $
 */

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/uio.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


char *
pop_retr(POSTAL_CONN *p_conn, int msgnum)
{
	char truebuf[BUFFER_SIZE+1];
	char *toret=NULL, *buf, *buf2;
	int moretoget=1, firsttime=1;
	int readlen, msize;

	/* Send request */
	sprintf(truebuf, "RETR %d\r\n", msgnum);
	POP_CMD_SEND(p_conn, truebuf);
	CLEARSTRING(truebuf);

	/* Start processing */
	while(moretoget)
	{
		/* Get the response */
		readlen=read(p_conn->spec.pop->sock, truebuf, BUFFER_SIZE);
		truebuf[readlen]='\0';
		buf=truebuf;

		/*
		 * If it's the first time through, make sure we're +OK.
		 * If we're not, we're in trouble, bail.
		 * XXX We really need a good error-handling system
		 */
		if(firsttime)
		{
			/* First, check that we have a good response, else bail */
			if( (strncmp(buf, POP_GOOD, strlen(POP_GOOD)) != 0) )
				return(NULL);
			buf2 = strchr(buf, (int) '\r');
			buf2+=2;
			buf = buf2;
			firsttime=0;
		}

		/* Store up the whole thing */
		msize = strlen(buf)+1;
		if(toret)
		{
			msize += strlen(toret);
			toret = realloc(toret, msize);
		}
		else
		{
			toret = malloc(msize);
			*toret = '\0';	/* This shouldn't be necessary.  Sigh. */
		}
		strcat(toret, buf);

		/*
		 * Check to see if we've got the 'end' of the return.
		 */
		buf2 = strrchr(toret, (int) '.');
		if(buf2)
		{
			if( (strncmp((buf2-2), "\r\n.\r\n", 5) == 0) )
			{
				/* We have it all now */
				moretoget=0;
				*(buf2-2) = '\0';
			}
		}
	} /* Got it all */

	/* Return the message we retrieved */
	return(toret);
}
