/*
 * pop_retr_all.c
 * Use RETR to get all messages on server
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_retr_all.c,v 1.4 2001/05/04 09:34:54 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


POSTAL_MSG_LIST *
pop_retr_all(POSTAL_CONN *p_conn, int dele)
{
	int mnum;
	POP_RET_STAT *ret_stat;
	POSTAL_MSG *ret_retr;
	POSTAL_MSG_LIST *head=NULL, *tmp, *tmp2, *tmp3;

	/* First, do a STAT to see how many messages we have */
	ret_stat = pop_stat(p_conn);

	/*
	 * Grab the parsed messages in order, and stick them
	 * into the structure.
	 */
	for(mnum=1 ; mnum <= pop_stat_msgs(ret_stat) ; mnum++)
	{
		/* Retrieve the message */
		ret_retr = pop_retr_parse(p_conn, mnum);

		/* Alloc a struct and point it in */
		tmp = malloc(PMSGLIST_SIZE);
		tmp->msg = ret_retr;

		/* Link up the linked list thingy */
		tmp->next = head;
		head = tmp;

		/* Are we DELE'ing too? */
		if(dele)
			pop_dele(p_conn, mnum);
	}

	/* Avoid a memory leak */
	free(ret_stat);

	/* Reverse the order, so HEAD is the first message */
	tmp3 = NULL;
	for(tmp = head ; tmp ; tmp = tmp2)
	{
		tmp2 = tmp->next;
		tmp->next = tmp3;
		tmp3 = tmp;
	}

	head = tmp3;

	/* That done, just return the puppy */
	return(head);
}
