/*
 * pop_retr_parse.c
 * Return a parsed-out RETR result
 * libpostal project
 * libpost_raw  POP code
 * $Id: pop_retr_parse.c,v 1.3 2001/05/03 10:32:50 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include <post_raw.h>
#include <post_raw_p.h>
#include <post_raw_pop_p.h>


POSTAL_MSG *
pop_retr_parse(POSTAL_CONN *p_conn, int msgnum)
{
	POSTAL_MSG *toret;
	char *ret_retr;
	char *tmpbuf;

	/* Do RETR request */
	ret_retr = pop_retr(p_conn, msgnum);

	/* Grab the headers */
	tmpbuf = strstr(ret_retr, "\r\n\r\n\0");
	if((tmpbuf==NULL))
	{
		/* Once again, we need error handling...  sigh. */
		return(NULL);
	}
	*tmpbuf='\0';
	tmpbuf += 4;

	/* Malloc me a hillock */
	toret = malloc(PMSG_SIZE);

	toret->header = malloc((strlen(ret_retr)+1));
	toret->body = malloc((strlen(tmpbuf)+1));
	strcpy(toret->header, ret_retr);
	strcpy(toret->body, tmpbuf);

	/* Clean up */
	free(ret_retr);

	return(toret);
}
