/*
 * getmsgs.c
 * Test the pop_retr() and prereq functions.
 * Specially designed to work in the compile tree
 * Links again: libpost_raw
 * Links shared
 * $Id: getmsgs2.c,v 1.2 2001/05/03 10:32:50 fullermd Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "../../include/post_raw/post_raw.h"


int
main(int argc, char *argv[])
{
	POSTAL_CONN *my_conn;
	POSTAL_MSG_LIST *ret_head, *ret_tmp;
	int dele=0;
	int goch;
	int mnum;
	char *p_serv, *p_user, *p_pass;

	if(argc<6)
	{
		printf("Need at least -h -u -p arguments, damn you!\n");
		exit(1);
	}

	while ( (goch = getopt(argc, argv, "dh:u:p:")) != -1 )
		switch((char)goch)
		{
			case 'd':
				/* Do DELE's */
				dele = 1;
				break;
			case 'h':
				/* Hostname */
				p_serv = optarg;
				break;
			case 'u':
				/* Username */
				p_user = optarg;
				break;
			case 'p':
				/* Password */
				p_pass = optarg;
				break;
			default:
				printf("Bad argument '%c'\n", goch);
				exit(1);
				/* NOTREACHED */
		}

	argc -= optind;
	argv += optind;

	printf("Running with host '%s', user '%s', and pass '%s'\n",
			p_serv, p_user, p_pass);

	my_conn = pop_connect(p_serv, p_user, p_pass);

	if(!my_conn)
	{
		printf("You lose, too bad!\n");
		exit(1);
	}

	/* Get all the messages at once with pop_retr_all() */
	ret_head = pop_retr_all(my_conn, dele);

	/* Print them all */
	mnum = 1;
	for(ret_tmp = ret_head ; ret_tmp ; ret_tmp = postal_mlist_next(ret_tmp))
	{
		printf("Message #%d:\n------\n%s\n\n%s\n------\n",
				mnum, postal_msg_header(postal_mlist_msg(ret_tmp)),
				postal_msg_body(postal_mlist_msg(ret_tmp)) );
		mnum++;
	}

	/* Free things up */
	postal_free_msglist(ret_head);

	pop_close(my_conn);

	exit(0);
}
